<?php

namespace App\Repository;

use App\Entity\LdapGroup;
use Doctrine\ORM\EntityRepository;

/**
 * GroupRepository.
 *
 * This class was generated by the Doctrine ORM. Add your own custom
 * repository methods below.
 */
class LdapGroupRepository extends EntityRepository
{
    /**
     * Return all the LdapGroup that have an operation to do.
     *
     * @return array|LdapGroup[]
     */
    public function getAllWithOperation()
    {
        $query = $this->createQueryBuilder('lg')
            ->where('lg.operation IS NOT NULL')
            ->getQuery();

        return $query->getResult();
    }

	public function findOneByName(string $name) {
		return $this->createQueryBuilder('lg')
					->where('LOWER(lg.name) LIKE :name')
					->setParameter('name', strtolower($name))
					->getQuery()
					->getOneOrNullResult();
	}

//    public function getAllChildrenGroups($name)
//    {
//        $em = $this->getEntityManager();
//
//
//        $ldapGroup = $em->getRepository('App\Entity\Student')->find($name);
//        if (!$ldapGroup) {
//            return array();
//        }
//        $members = $ldapGroup->getMembersList();
//        if (array_key_exists('group', $members)) {
//            $membership = $members['group'];
//        } else {
//            $membership = array();
//        }
//
//
//        return $membership;
//
//
//    }

//    public function getAllChildrenUsers($name)
//    {
//        $em = $this->getEntityManager();
//
//
//        $ldapGroup = $em->getRepository('App\Entity\LdapGroup')->find($name);
//        $members = $ldapGroup->getMembersList();
//        if (array_key_exists('user', $members)) {
//            $membership = $members['user'];
//        } else {
//            $membership = array();
//        }
//
//
//        return $membership;
//
//
//    }

    public function getAllChildrenRecursiveUsers($ldapGroup)
    {
        $em = $this->getEntityManager();

        if (is_string($ldapGroup) && '' != $ldapGroup) {
            $ldapGroup = $em->getRepository('App\Entity\LdapGroup')->find($ldapGroup);
        }

        if (!$ldapGroup instanceof LdapGroup) {
            return [];
        }

        $members = $ldapGroup->getMembersList();
        if (!isset($members['group']) || null == $members['group']) {
            $members['group'] = [];
        } elseif (is_object($members['group'])) {
            $members['group'] = (array) $members['group'];
        }

        if (!isset($members['user'])) {
            $members['user'] = [];
        } elseif (is_object($members['user'])) {
            $members['user'] = (array) $members['user'];
        }

        $users = $members['user'];

        foreach ($members['group'] as $group) {
            if ('' == $group) {
                continue;
            }

            $groupUsers = $em->getRepository('App\Entity\LdapGroup')->getAllChildrenRecursiveUsers($group);
            if (is_array($groupUsers) && !empty($groupUsers)) {
                $users = array_merge($users, $groupUsers);
            }
        }

        return $users;
    }

//    public function getAllStudentsInThisGroup($rootGroup, $subGroup)
//    {
//        $em = $this->getEntityManager();
//
//
//        $membership = array();
//        $groups = $em->getRepository('App\Entity\LdapGroup')->findAll();
//        foreach ($groups as $group) {
//            $g = $group->getMembersList();
//            if ((array_key_exists('user', $g)) and ($this->distinguishedId == $g['user'])) {
//                $membership[] = $group->getName();
//            }
//        }
//
//
//        $membership = array_unique($membership);
//
//        return $membership;
//
//        $query = $em->createQuery(
//            'SELECT s.username, s.email
//                    FROM ZenIgrooveBundle:Student s,  ZenIgrooveBundle:GroupComposition c
//                    WHERE c.subGroup = :subGroup and c.rootGroup = :rootGroup and s.id = c.student'
//        )
//            ->setParameter('subGroup', $subGroup)
//            ->setParameter('rootGroup', $rootGroup);
//        $results = $query->getResult();
//        $studentsUsernameList = array();
//        foreach ($results as $result) {
//            $studentsUsernameList[$result['username']] = $result['email'];
//        }
//
//        return $studentsUsernameList;
//    }

    public function getInternetStatus($ldapGroupName, $active_directory_generated_group_prefix)
    {
        $em = $this->getEntityManager();
        $ldapGroup = $em->getRepository('App\Entity\LdapGroup')->find(
            $active_directory_generated_group_prefix.'InternetAccess'
        );
        if (!$ldapGroup instanceof LdapGroup) {
            return 'not-active';
        }

        $members = $ldapGroup->getMembersList();
        if (array_key_exists('group', $members) and in_array($ldapGroupName, $members['group'])) {
            return 'group-active';
        }

        $ldapGroup = $em->getRepository('App\Entity\LdapGroup')->find(
            $ldapGroupName
        );
        if ($ldapGroup) {
            $members = $ldapGroup->getMembersList();
            if (array_key_exists('user', $members)) {
                foreach ($members['user'] as $username) {
                    $status = $em->getRepository('App\Entity\LdapUser')->getInternetStatus(
                        $username,
                        $active_directory_generated_group_prefix
                    );
                    if ('not-active' != $status) {
                        return 'user-active';
                    }
                }
            }
        }

        return 'not-active';
    }

    /**
     * function ldap_escape.
     *
     * @author Chris Wright
     *
     * @version 2.0
     *
     * @param string $subject The subject string
     *
     * @return string The escaped string
     *
     * $user = 'Test , Name S.L';
     * if (!ldap_add($ds, "cn=".ldap_escape($user, TRUE).",".LDAP_DN_BASE, $info)) {
     *  include 'error_new_account.php';
     * }
     */
    public static function ldapEscape($subject)
    {
        $subject = str_replace(
            [
                'à',
                'á',
                'â',
                'ã',
                'ä',
                'ç',
                'è',
                'é',
                'ê',
                'ë',
                'ì',
                'í',
                'î',
                'ï',
                'ñ',
                'ò',
                'ó',
                'ô',
                'õ',
                'ö',
                'ù',
                'ú',
                'û',
                'ü',
                'ý',
                'ÿ',
                'À',
                'Á',
                'Â',
                'Ã',
                'Ä',
                'Ç',
                'È',
                'É',
                'Ê',
                'Ë',
                'Ì',
                'Í',
                'Î',
                'Ï',
                'Ñ',
                'Ò',
                'Ó',
                'Ô',
                'Õ',
                'Ö',
                'Ù',
                'Ú',
                'Û',
                'Ü',
                'Ý',
            ],
            [
                'a',
                'a',
                'a',
                'a',
                'a',
                'c',
                'e',
                'e',
                'e',
                'e',
                'i',
                'i',
                'i',
                'i',
                'n',
                'o',
                'o',
                'o',
                'o',
                'o',
                'u',
                'u',
                'u',
                'u',
                'y',
                'y',
                'A',
                'A',
                'A',
                'A',
                'A',
                'C',
                'E',
                'E',
                'E',
                'E',
                'I',
                'I',
                'I',
                'I',
                'N',
                'O',
                'O',
                'O',
                'O',
                'O',
                'U',
                'U',
                'U',
                'U',
                'Y',
            ],
            $subject
        );
        $ignore = [
            ':',
            '/',
            '\\',
            ',',
            '=',
            '+',
            '<',
            '>',
            ';',
            '"',
            '#',
            "'",
            '(',
            ')',
            "'",
            "\x00",
            '?',
            '.',
            '-',
            '*',
            '!',
        ];
        $subject = str_replace('  ', ' ', $subject);

        //@todo improve strip to prevent use of emoji and other utf8/16 char in username

        return trim(substr(str_replace($ignore, '', $subject), 0, 50));
    }
}
